<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: economicalBowlers.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: economicalBowlers.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * This moudule accepts matches and deliveries data to return the object with top 10 economical bowlers in the given year
 * @module economicalBowlers
 */

/**
 * the object with match id as keys for all the matches in given year
 * {@link module:matchesInGivenYear}
 * @type {Object}
 * @returns an object with top 10 economical bowlers in the given year
 */
const calcEconomy = require("./calcEconomy");
const matchesInGivenYear = require("./matchesInGivenYear");

/**
 *
 * @param {Array.&lt;Object>} matchesData parsed JSON data of matches
 * @param {Array.&lt;Object>} deliveriesData parsed JSON data of deliveries
 * @param {number|string} year year in which to get top economical bowlers
 * @returns {Object}
 */

const economicalBowlers = (matchesData, deliveriesData, year = 2015) => {
  if (!Array.isArray(matchesData) || !Array.isArray(deliveriesData)) return {};

  // matchesInGivenYear returns the object with match id as keys, so that lookup is O(1).
  const matchesById = matchesInGivenYear(matchesData, year);

  const bowlersData = deliveriesData.filter(
    (delivery) => matchesById[delivery.match_id] !== undefined
  );

  const economyOfPlayers = calcEconomy(bowlersData);

  return Object.fromEntries(
    Object.entries(economyOfPlayers)
      .sort((a, b) => a[1].economy - b[1].economy)
      .slice(0, 10)
  );
};

module.exports = economicalBowlers;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">IPL Project</a></h2><h3>Modules</h3><ul><li><a href="module-bestSuperoverEconomy.html">bestSuperoverEconomy</a></li><li><a href="module-calcEconomy.html">calcEconomy</a></li><li><a href="module-config.html">config</a></li><li><a href="module-economicalBowlers.html">economicalBowlers</a></li><li><a href="module-extraRunsPerTeam.html">extraRunsPerTeam</a></li><li><a href="module-matchesInGivenYear.html">matchesInGivenYear</a></li><li><a href="module-matchesPerYear.html">matchesPerYear</a></li><li><a href="module-matchesWonPerTeam.html">matchesWonPerTeam</a></li><li><a href="module-matchesWonWithToss.html">matchesWonWithToss</a></li><li><a href="module-playerDismissed.html">playerDismissed</a></li><li><a href="module-playerOfTheMatch.html">playerOfTheMatch</a></li><li><a href="module-saveOutput.html">saveOutput</a></li><li><a href="module-strikeRate.html">strikeRate</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Wed May 26 2021 15:19:05 GMT+0530 (India Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
